/*
 * Licensed Materials - Property of IBM
 * 
 * 		5724-I66
 * 
 * (C) Copyright IBM Corporation 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */ 
package com.emerged.bank;


public class BankBean {
    private BankDatabaseBean dbBean = null;
	/**
	 * 
	 */
	public BankBean() {
		super();
        dbBean = new BankDatabaseBean();
	}

    public Customer createCustomer(Customer customer) throws Exception {
    	Customer c = null;
    	
          try {
          	c = dbBean.createCustomer( customer );
          }
          catch(Exception e){
          	throw e;
          }
          return c;
    }
	
    public Customer retrieveCustomer(Customer customer) throws Exception {
    	Customer c = null;
    	
          try {
          	c = dbBean.retrieveCustomer( customer );
          }
          catch(Exception e){
          	throw e;
          }
          return c;
    }
    public Customer updateCustomer(Customer customer) throws Exception {
    	Customer c = null;
    	
          try {
          	c = dbBean.updateCustomer( customer );
          }
          catch(Exception e){
          	throw e;
          }
          return c;
    }

    public Customer deleteCustomer(Customer customer) throws Exception {
    	Customer c = null;
    	
          try {
          	c = dbBean.deleteCustomer( customer );
          }
          catch(Exception e){
          	throw e;
          }
          return c;
    }
   
	public Account createAccount(Customer customer,Account account) throws Exception {
		Account a = null;
		
		try {
		   a = dbBean.createAccount(customer, account);
		   
		}
		catch(Exception e) {
			throw e;
		}
		
		return a;
	}

    public Account retrieveAccount(Account account) throws Exception {
    	
		Account a = null;
		
		try {
		   a = dbBean.retrieveAccount(account);
		}
		catch(Exception e) {
			throw e;
		}
		
		return a;
    }
    
    public Account updateAccount(Account account) throws Exception {
		Account a = null;
		
		try {
		   a = dbBean.updateAccount(account);
		}
		catch(Exception e) {
			throw e;
		}
		
		return a;
    	
    }
    
	public Account deleteAccount(Customer customer,Account account) throws Exception {
		Account a = null;
		
		try {
		   a = dbBean.deleteAccount(customer, account);
		}
		catch(Exception e) {
			throw e;
		}
		
		return a;
	}
   
    public ContactInfo createContactInfo(ContactInfo contactInfo) throws Exception {
    	
    	ContactInfo ci = null;
		
		try {
		   ci = dbBean.createContactInfo(contactInfo);
		}
		catch(Exception e) {
			throw e;
		}
		
		return ci;
    	
    }
    
    public ContactInfo updateContactInfo(ContactInfo contactInfo) throws Exception {
    	
    	ContactInfo ci = null;
		
		try {
		   ci = dbBean.updateContactInfo(contactInfo);
		}
		catch(Exception e) {
			throw e;
		}
		
		return ci;
    	
    }
    
    public ContactInfo retrieveContactInfo(ContactInfo contactInfo) throws Exception {
    	
    	ContactInfo ci = null;
		
		try {
		   ci = dbBean.retrieveContactInfo(contactInfo);
		}
		catch(Exception e) {
			throw e;
		}
		
		return ci;
    	
    }    
    
    public ContactInfo deleteContactInfo(ContactInfo contactInfo) throws Exception {
    	
    	ContactInfo ci = null;
		
		try {
		   ci = dbBean.deleteContactInfo(contactInfo);
		}
		catch(Exception e) {
			throw e;
		}
		
		return ci;
    	
    }   
    
    public Account[] getAccounts(Customer customer) throws Exception {
    	Account[] as = null;
		
		try {
		   as = dbBean.getAccounts(customer);
		}
		catch(Exception e) {
			throw e;
		}
		
		return as;
    	
    }
    
    public Account deposit(Account account, Double amount) throws Exception {
    	
		Account a = null;
		
		try {
		   a = dbBean.deposit(account,amount);
		}
		catch(Exception e) {
			throw e;
		}
		
		return a;
    	
    	
    }
    
    public Account withdraw(Account account, Double amount) throws Exception {
    	
		Account a = null;
		
		try {
		   a = dbBean.withdraw(account,amount);
		}
		catch(Exception e) {
			throw e;
		}
		
		return a;
    	
    	
    }

    public Account transfer(Account accountFrom,Account accountTo, Double amount) throws Exception {

    	
		try {
		   accountFrom = dbBean.transfer(accountFrom,accountTo,amount);
		}
		catch(Exception e) {
			throw e;
		}
    	
		return accountFrom;
    }
   
    public boolean isWebLoginInfoValid(String customer, String password)  throws Exception {
    	
        boolean bValid = false;
    	
		try {
			bValid = dbBean.isWebLoginValid( customer, password );
		}
		catch(Exception e) {
			throw e;
		}
		
		return bValid;
    }
    
}
