/*
 * Licensed Materials - Property of IBM
 * 
 * 		5724-I66
 * 
 * (C) Copyright IBM Corporation 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */ 
package com.emerged.brokerage;

import java.sql.*;
import java.util.Vector;

import com.emerged.brokerage.BrokerageDatabaseConstants;

public class BrokerageDatabaseBean {

    private com.ibm.db2j.jdbc.DB2jDataSource ds = null;
    private Connection c = null;
    private String sFileSeparator = java.io.File.separator;
	private String sRowID = null;
	
	public BrokerageDatabaseBean() {
		super();
		try {
			   getDataSource();	
			}
			catch(Exception e) {
				e.printStackTrace();
			}
		}

	    private void getDataSource() throws Exception {

	        try {    	
	        	
	        	
	           Class cds = Class.forName("com.ibm.db2j.jdbc.DB2jDataSource");
	           ds = (com.ibm.db2j.jdbc.DB2jDataSource) cds.newInstance();
	           ds.setDatabaseName(BrokerageDatabaseConstants.sDBPath + sFileSeparator + BrokerageDatabaseConstants.sDatabaseName);

	                
	        }
	        catch(Exception e) {
	               throw e;
	        }
	    	
	    }
	    
	    private void extraStuff4Linux() {
	    	
	    	 /*
	    	  *  This code is linux/cloudscape workaround.
	    	  *  It is used to avoid getting the following message:
	    	  *  WARNING: Cloudscape (instance c013800d-00f2-15b3-5c65-00091aa1ce00) is attempting to boot the database /home/userid/cloudscapedbs/eMergedScenarioBankAccountDB even though Cloudscape (instance c013800d-00f2-15b3-1356-00091aa1ce00) may still be active.  Only one instance of Cloudscape should boot a database at a time. Severe and non-recoverable corruption can result and may have already occurred.
	    	  * 
	    	  */ 
	    	
		     try {
		         DriverManager.getConnection("jdbc:db2j:" + BrokerageDatabaseConstants.sDBPath + sFileSeparator + BrokerageDatabaseConstants.sDatabaseName + ";shutdown=true");        	                	
		     }
		     catch(Exception e) {
		     	//shutting down always throws an exception
		     }    	    	
	    	
	    }
	    
	    private void closeConnection()  throws Exception {
	    	
	     try {

	         if ( c != null) {         	
	             c.close();
	             c = null;
	         }
	         
	         extraStuff4Linux();

	     }
	     catch(Exception e) {
	     	throw e;
	     }
	    	
	    }

	     private Connection getConnection() throws Exception {

	       try {
	       	
	          if ( c == null) {
	   	           c = ds.getConnection();                	
	          }
	       }
	       catch(Exception e) {
	       	 throw e;
	       }

	       return c;
	          
	     }

	 	public Customer createCustomer(Customer inputCustomer) {
	 		
	 		boolean dbError = false;
        	Customer original = inputCustomer;
        	
	        try {


	        	
	        	
	            PreparedStatement ptstmt = null;
	            ResultSet         rs     = null;
	            
	            Connection con = getConnection();            
	            String sCountSQL = "select count(customernumber) from customers";
	            sCountSQL = sCountSQL.toUpperCase();                                    
	            long iCustomers = -1;
	            

	            
	            //get number of rows (customers)            
	            ptstmt = con.prepareStatement(sCountSQL);
	            rs = ptstmt.executeQuery();
	            while (rs.next()) {
	            	iCustomers = rs.getLong(1);
	            }//while

	            
	            if (iCustomers == 0) {
	               sRowID = BrokerageDatabaseConstants.sFirstCustomerID;                 
	            }//if                       
	            else {//find biggest and increment by 1
	                
	               String sMAXSQL = "select max(customernumber) from customers";
	               sMAXSQL = sMAXSQL.toUpperCase(); 
	               long iCurrentMax = -1;
	               long iNewMax = -1;
	               
	               //get max customernumber           
	               ptstmt = con.prepareStatement(sMAXSQL);
	               rs = ptstmt.executeQuery();
	               while (rs.next()) {
	                iCurrentMax = rs.getLong(1);
	               }//while
	                                
	               iNewMax = (iCurrentMax + 1);
	                                
	               sRowID = new Long(iNewMax).toString();             
	                
	            }//endif

	 
	            //create the new customer            
	            //i.e.
                //insert into customers values ('8888000000','20/04/1972','sin','firstName','lastName','street','city','state','country','zip','phoneNumber', 0.0 , 3000.00)	            

	             
	            String sInsertSQL = null;
	            sInsertSQL = "insert into customers values (?,?,?,?,?,?,?,?,?,?,?,?,?)";
	            sInsertSQL = sInsertSQL.toUpperCase();            
	            ptstmt = con.prepareStatement(sInsertSQL);
	            
	            inputCustomer.setCustomerNumber( sRowID );
	            ptstmt.setString(1, inputCustomer.getCustomerNumber() );
	            ptstmt.setString(2, inputCustomer.getCustomerSince() );	            
	            ptstmt.setString(3, inputCustomer.getSin() );            
	            ptstmt.setString(4, inputCustomer.getFirstName() );
	            ptstmt.setString(5, inputCustomer.getLastName() );
	            ptstmt.setString(6, inputCustomer.getAddress().getStreet() );
	            ptstmt.setString(7, inputCustomer.getAddress().getCity() );
	            ptstmt.setString(8, inputCustomer.getAddress().getState() );
	            ptstmt.setString(9, inputCustomer.getAddress().getCountry() );
	            ptstmt.setString(10, inputCustomer.getAddress().getZipCode() );
	            ptstmt.setString(11, inputCustomer.getPhoneNumber() );
	            ptstmt.setDouble(12, inputCustomer.getCashBalance().doubleValue() );
	            ptstmt.setDouble(13, inputCustomer.getMaximumTransactionAmount().doubleValue() );
	            ptstmt.executeUpdate();

	            int iNumberOfStockSymbols = 0;
	            
	            if (inputCustomer.getNumberOfStockSymbols() != null){
	                  iNumberOfStockSymbols = inputCustomer.getNumberOfStockSymbols().intValue();
	            }//if
	            
	            if (iNumberOfStockSymbols > 0) {
	            	
	            	for(int i=0;i<iNumberOfStockSymbols;i++){
	    	            sInsertSQL = "insert into stocks values (?,?,?)";
	    	            sInsertSQL = sInsertSQL.toUpperCase();            
	    	            ptstmt = con.prepareStatement(sInsertSQL);
	    	            ptstmt.setString(1, inputCustomer.getCustomerNumber() );
	    	            ptstmt.setString(2, inputCustomer.getStockSymbols()[i] );            
	    	            ptstmt.setInt(3, inputCustomer.getQuantityOfShares()[i].intValue() );
	    	            ptstmt.executeUpdate();
	            	}//for
	            	
	            }//if
	            
	            ptstmt.close();                     
	            rs.close();
	            closeConnection();

	            
	        }//try
	        catch(Exception e) {
	        	e.printStackTrace();
	        	dbError = true;	        	
	        }//catch
	        
	        if (dbError) {
	           inputCustomer = original;
	           inputCustomer.setReturnCode(new Integer(BrokerageDatabaseConstants.ERROR));
	        }//if
	        else {
	           inputCustomer.setOldData(null);
		       inputCustomer.setReturnCode(new Integer(BrokerageDatabaseConstants.SUCCESS));	        	
	        }
	        
	     	return inputCustomer;

		}
		
		public Customer updateCustomer(Customer inputCustomer) {
			
	 		boolean dbError = false;
        	Customer original = inputCustomer;
        	
        	

        	Customer existing = new Customer();
        	existing.setCustomerNumber( inputCustomer.getCustomerNumber() );
			
	         try {

	         	existing = retrieveCustomer( existing );
         	    if ( existing.getReturnCode().intValue() == BrokerageDatabaseConstants.ERROR ) {
	         	  	 throw new Exception("Customer '" + existing.getCustomerNumber() + "' does not exist.");
	         	}//if
	         	

	            Connection con = getConnection();
	            
	            PreparedStatement ptstmt = null;


	            
		          //update the customer info
		          //i.e.
		          // update customers set customersince = ?, sin = ?, firstname = ?, lastname = ?, street = ?, city = ?, state = ?, country = ?, zipCode = ?, phoneNumber = ?, cashBalance = ?, maximumTransactionAmount = ? where customernumber = ?
		          String sUpdateSQL = null;            
		          sUpdateSQL = "update customers set customersince = ?, sin = ?, firstname = ?, lastname = ?, street = ?, city = ?, state = ?, country = ?, zipCode = ?, phoneNumber = ?, cashBalance = ?, maximumTransactionAmount = ? where customernumber = ?";
		          sUpdateSQL = sUpdateSQL.toUpperCase();            
		          
		          ptstmt = con.prepareStatement(sUpdateSQL);
		          ptstmt.setString(1, inputCustomer.getCustomerSince() );		          
		          ptstmt.setString(2, inputCustomer.getSin() );	          
		          ptstmt.setString(3, inputCustomer.getFirstName() );
		          ptstmt.setString(4, inputCustomer.getLastName() );	          
		          ptstmt.setString(5, inputCustomer.getAddress().getStreet() );
		          ptstmt.setString(6, inputCustomer.getAddress().getCity() );
		          ptstmt.setString(7, inputCustomer.getAddress().getState() );
		          ptstmt.setString(8, inputCustomer.getAddress().getCountry() );
		          ptstmt.setString(9, inputCustomer.getAddress().getZipCode() );
		          ptstmt.setString(10, inputCustomer.getPhoneNumber() );
		          ptstmt.setDouble(11, inputCustomer.getCashBalance().doubleValue() );
		          ptstmt.setDouble(12, inputCustomer.getMaximumTransactionAmount().doubleValue() );
		          ptstmt.setString(13, inputCustomer.getCustomerNumber() );
		          
		          ptstmt.executeUpdate();


	            ptstmt.close();                     

	            closeConnection();
	            

	            
	            
	        }//try
	        catch(Exception e) {
	        	e.printStackTrace();
	        	dbError = true;
	        }//catch
	        
	        if (dbError) {
		           inputCustomer = original;
		           inputCustomer.setReturnCode(new Integer(BrokerageDatabaseConstants.ERROR));
		    }//if
		    else {
		    	   OldCustomer oc = new OldCustomer();
		    	   oc.setCustomerNumber( existing.getCustomerNumber() );
		    	   oc.setCustomerSince( existing.getCustomerSince() );
		    	   oc.setFirstName( existing.getFirstName() );		    	   
		    	   oc.setLastName( existing.getLastName() );
		    	   oc.setPhoneNumber( existing.getPhoneNumber() );
		    	   oc.setSin( existing.getSin() );
		    	   oc.setMaximumTransactionAmount( existing.getMaximumTransactionAmount() );
		    	   oc.setCashBalance( existing.getCashBalance() );
		    	   oc.setAddress( existing.getAddress() );
		    	   oc.setNumberOfStockSymbols( existing.getNumberOfStockSymbols() );
		    	   oc.setStockSymbols( existing.getStockSymbols() );
		    	   oc.setQuantityOfShares( existing.getQuantityOfShares() );
		    	   inputCustomer.setOldData( oc );
		    	   
		    	   inputCustomer.setNumberOfStockSymbols( existing.getNumberOfStockSymbols() );
		    	   inputCustomer.setStockSymbols( existing.getStockSymbols() );
		    	   inputCustomer.setQuantityOfShares( existing.getQuantityOfShares() );
			       inputCustomer.setReturnCode(new Integer(BrokerageDatabaseConstants.SUCCESS));	        	
		    }
	 	    
            return inputCustomer;
            
		}
		
		public Customer retrieveCustomer(Customer inputCustomer) {

            boolean bRecordFound = false;			
	 		boolean dbError = false;
        	Customer original = inputCustomer;
			
	         try {


	            
	            Connection con = getConnection();
	            
	            PreparedStatement ptstmt = null;
	            ResultSet rs = null;
	            Address address = null;
	            
		          //retrieve the customer
		          //i.e.   
		          // select customernumber,customersince,sin,firstname,lastname,street,city,state,country,zipCode,phoneNumber,cashBalance,maximumTransactionAmount from customers where customernumber = ?
		          String sSelectSQL = null;            
		          sSelectSQL = "select customernumber,customersince,sin,firstname,lastname,street,city,state,country,zipCode,phoneNumber,cashBalance,maximumTransactionAmount from customers where customernumber = ?";
		          sSelectSQL = sSelectSQL.toUpperCase();            
		          
		        ptstmt = con.prepareStatement(sSelectSQL);
		        ptstmt.setString(1, inputCustomer.getCustomerNumber() );
		        rs = ptstmt.executeQuery();
		        while (rs.next()) {
		          bRecordFound = true;
		          inputCustomer.setCustomerNumber( rs.getString("customernumber") );
		          inputCustomer.setCustomerSince( rs.getString("customersince") );		          
		          inputCustomer.setSin( rs.getString("sin") );	          
		          inputCustomer.setFirstName( rs.getString("firstname") );
		          inputCustomer.setLastName( rs.getString("lastname") );
		          
		          address = new Address();
		          address.setStreet( rs.getString("street") );
		          address.setCity( rs.getString("city") );		          
		          address.setState( rs.getString("state") );
		          address.setCountry( rs.getString("country") );
		          address.setZipCode( rs.getString("zipCode") );
		          inputCustomer.setAddress( address );
		          
		          inputCustomer.setPhoneNumber( rs.getString("phoneNumber") );
		          inputCustomer.setCashBalance( new Double( rs.getDouble("cashBalance") ) );
		          inputCustomer.setMaximumTransactionAmount( new Double( rs.getDouble("maximumTransactionAmount") ) );

		          
		        }//while

		        
		        if (bRecordFound) {
		        	

			            	
					        sSelectSQL = "select customers.customernumber,symbol,quantity from customers,stocks where customers.customernumber=stocks.customernumber and customers.customernumber = ?";
					        sSelectSQL = sSelectSQL.toUpperCase();            
					          
					        ptstmt = con.prepareStatement(sSelectSQL);
					        ptstmt.setString(1, inputCustomer.getCustomerNumber() );
					        rs = ptstmt.executeQuery();
	
					        Vector stockSymbols = new Vector();
					        Vector qtyShares = new Vector();
					        
					        while (rs.next()) {
	                          stockSymbols.add( rs.getString("symbol") );
	                          qtyShares.add( new Integer(rs.getInt("quantity")) );
					        }//while
	
					        if (stockSymbols.size() > 0) {
					        	inputCustomer.setNumberOfStockSymbols( new Integer( stockSymbols.size() ) );
					        	inputCustomer.setStockSymbols( (String[])stockSymbols.toArray( new String[0] ) );
					        	inputCustomer.setQuantityOfShares( (Integer[])qtyShares.toArray( new Integer[0] ) );
					        	stockSymbols = null;
					        	qtyShares = null;
					        }//if
					        else {
					        	inputCustomer.setNumberOfStockSymbols( new Integer( 0 ) );
					        }
					        
		        }//if
		        
		        rs.close();
	            ptstmt.close();                     
	            closeConnection();
	            
	            
	        }//try
	        catch(Exception e) {
	        	e.printStackTrace();
	        	dbError = true;
	        }//catch
	         
	        
	        if (dbError) {
		           inputCustomer = original;
		           inputCustomer.setReturnCode(new Integer(BrokerageDatabaseConstants.ERROR));
		    }//if
		    else {//not a db error
	               if (!bRecordFound) {//record didn't exist
			           inputCustomer = original;
			           inputCustomer.setReturnCode(new Integer(BrokerageDatabaseConstants.ERROR));
			           try {
			           	  throw new Exception("Customer '" + inputCustomer.getCustomerNumber() + "' does not exist.");
			           }
			           catch(Exception e){
			           	  e.printStackTrace();
			           }
	               }//if
	               else {//record existed
			           inputCustomer.setReturnCode(new Integer(BrokerageDatabaseConstants.SUCCESS));
	               }//endif
		    }
	        
	        return inputCustomer;

		}

		
		public Customer deleteCustomer(Customer inputCustomer) {

            boolean bRecordFound = false;			
	 		boolean dbError = false;
        	Customer original = inputCustomer;
			
         try {

         	  inputCustomer = retrieveCustomer( inputCustomer );//just in case the Customer input variable isn't completely initialized
	       	    if ( inputCustomer.getReturnCode().intValue() == BrokerageDatabaseConstants.ERROR ) {
	        	  	 throw new Exception("Customer '" + inputCustomer.getCustomerNumber() + "' does not exist.");
	        	}//if
	          
	          Connection con = getConnection();
	          PreparedStatement ptstmt = null;
	          
	          //delete this customer
	          //i.e.
	          // delete from customers  where customernumber = ?
	          String sDeleteSQL = null;            
	          sDeleteSQL = "delete from customers  where customernumber = ?";
	          sDeleteSQL = sDeleteSQL.toUpperCase();            
	          
	          ptstmt = con.prepareStatement(sDeleteSQL);
	          ptstmt.setString(1, inputCustomer.getCustomerNumber() );                                                
	          ptstmt.executeUpdate();

	          String[] stockSymbols = inputCustomer.getStockSymbols();
	          
	          if (stockSymbols != null) {
	          	
		          //delete this customer's stock symbols
		          //i.e.
		          // delete from stocks where customernumber = ? and symbol = ?
	          	
		        sDeleteSQL = "delete from stocks where customernumber = ? and symbol = ?";
		        sDeleteSQL = sDeleteSQL.toUpperCase();		        
	          	for (int i = 0; i < stockSymbols.length; i++) {
	  	          ptstmt = con.prepareStatement(sDeleteSQL);
		          ptstmt.setString(1, inputCustomer.getCustomerNumber() );                                                
		          ptstmt.setString(2, stockSymbols[i] );		          
		          ptstmt.executeUpdate();
				}//for
	          }//if
	          
	          ptstmt.close();                     
	          closeConnection();
	            
	        }//try
	        catch(Exception e) {
	        	e.printStackTrace();
	        	dbError = true;
	        }//catch
	         
	        if (dbError) {
		           inputCustomer = original;
		           inputCustomer.setReturnCode(new Integer(BrokerageDatabaseConstants.ERROR));
		    }//if
		    else {
		    	
	    	   OldCustomer oc = new OldCustomer();
	    	   oc.setCustomerNumber( inputCustomer.getCustomerNumber() );
	    	   oc.setCustomerSince( inputCustomer.getCustomerSince() );	    	   
	    	   oc.setFirstName( inputCustomer.getFirstName() );		    	   
	    	   oc.setLastName( inputCustomer.getLastName() );
	    	   oc.setPhoneNumber( inputCustomer.getPhoneNumber() );
	    	   oc.setSin( inputCustomer.getSin() );
	    	   oc.setMaximumTransactionAmount( inputCustomer.getMaximumTransactionAmount() );
	    	   oc.setCashBalance( inputCustomer.getCashBalance() );
	    	   oc.setAddress( inputCustomer.getAddress() );
	    	   oc.setNumberOfStockSymbols( inputCustomer.getNumberOfStockSymbols() );
	    	   oc.setStockSymbols( inputCustomer.getStockSymbols() );
	    	   oc.setQuantityOfShares( inputCustomer.getQuantityOfShares() );
		       
	    	   inputCustomer.setOldData( oc );
		       inputCustomer.setCustomerNumber(null);		    	
		       inputCustomer.setCustomerSince(null);		       
		       inputCustomer.setFirstName(null);
		       inputCustomer.setLastName(null);
		       inputCustomer.setSin(null);
		       inputCustomer.setMaximumTransactionAmount(null);
		       inputCustomer.setNumberOfStockSymbols(null);
		       inputCustomer.setPhoneNumber(null);
		       inputCustomer.setAddress(null);
		       inputCustomer.setCashBalance(null);
		       inputCustomer.setQuantityOfShares(null);
		       inputCustomer.setStockSymbols(null);
		       inputCustomer.setCustomerNumber(null);
		       
	           inputCustomer.setReturnCode(new Integer(BrokerageDatabaseConstants.SUCCESS));
		    }
	        
	        return inputCustomer;

		}
		
		public SharesRequest buyShares(SharesRequest inputSharesRequest) {

	 		SharesRequest original = inputSharesRequest;
	 		
			
	 		boolean dbError = false;

	 		
	 		
	 		boolean bCustomerAlreadyOwnsSomeOfThisStock = false;
	 		int     iStockSymbolIndex = -1;
	 		Integer updatedTotalQuantityOfShares = null;

        	String[] stockSymbols = null;
        	Integer[] quantity = null;
    	    Double totalCostOfPurchase  = null;
      	    Double totalCostOfPurchasePlusFee = null;
      	    Double cashBalance  = null;	          	  
	 		
        	Customer c = new Customer();
        	c.setCustomerNumber( inputSharesRequest.getCustomerNumber() );
        	
        	

			
         try {

         	  c = retrieveCustomer( c );
         	  
         	  if ( c.getReturnCode().intValue() == BrokerageDatabaseConstants.ERROR ) {
         	  	 throw new Exception("Customer '" + inputSharesRequest.getCustomerNumber() + "' does not exist.");
         	  }//if
	        
         	  stockSymbols = c.getStockSymbols();
         	  quantity     = c.getQuantityOfShares();

         	  if ( stockSymbols != null) {
         	  	 for(int i=0; i<stockSymbols.length;i++){
         	  	 	if ( stockSymbols[i].equals( inputSharesRequest.getStockSymbol() )  ) {
         	  	 	   bCustomerAlreadyOwnsSomeOfThisStock = true;
         	  	 	   iStockSymbolIndex = i;
         	  	 	   break;
         	  	 	}//if
         	  	 }//for
         	  }//if
         	  
         	  
	          Connection con = getConnection();
	          PreparedStatement ptstmt = null;
	          
	          if (!bCustomerAlreadyOwnsSomeOfThisStock) {
	          	
	            String sInsertSQL = "insert into stocks values (?,?,?)";
	            sInsertSQL = sInsertSQL.toUpperCase();            
	            ptstmt = con.prepareStatement(sInsertSQL);
	            
	            ptstmt.setString(1, inputSharesRequest.getCustomerNumber() );
	            ptstmt.setString(2, inputSharesRequest.getStockSymbol() );            
	            ptstmt.setInt(3, inputSharesRequest.getQuantityOfShares().intValue() );
	            
	            ptstmt.executeUpdate();
	            
	            updatedTotalQuantityOfShares = new Integer(inputSharesRequest.getQuantityOfShares().intValue());
	            
	          }//if
	          else {
	          	

		          String sUpdateSQL = null;            
		          sUpdateSQL = "update stocks set quantity = ? where customernumber = ? and symbol = ?";
		          sUpdateSQL = sUpdateSQL.toUpperCase();            
		          
		          ptstmt = con.prepareStatement(sUpdateSQL);
		          updatedTotalQuantityOfShares = new Integer(  inputSharesRequest.getQuantityOfShares().intValue() + quantity[iStockSymbolIndex].intValue()  );
		          
		          ptstmt.setInt(1, updatedTotalQuantityOfShares.intValue() );	          
		          ptstmt.setString(2, inputSharesRequest.getCustomerNumber() );
		          ptstmt.setString(3, inputSharesRequest.getStockSymbol() );	          
		          ptstmt.executeUpdate();

	          	
	          	
	          }//endif
	          
	          
	          
	          	

          	  totalCostOfPurchase        = new Double( inputSharesRequest.getQuantityOfShares().intValue() * inputSharesRequest.getPricePerShare().doubleValue()  );
          	  totalCostOfPurchasePlusFee = new Double( totalCostOfPurchase.doubleValue() + inputSharesRequest.getCommission().doubleValue() );

          	  cashBalance  = c.getCashBalance(); //current balance	          	  
          	  cashBalance = new Double(  cashBalance.doubleValue() - totalCostOfPurchasePlusFee.doubleValue() );

          	  
	          //update the customer info
	          //i.e.
	          //update customers set cashBalance = ? where customernumber = ?
	          String sUpdateSQL = null;            
	          sUpdateSQL = "update customers set cashBalance = ? where customernumber = ?";
	          sUpdateSQL = sUpdateSQL.toUpperCase();            
	          
	          ptstmt = con.prepareStatement(sUpdateSQL);
	          ptstmt.setDouble(1, cashBalance.doubleValue() );	          
	          ptstmt.setString(2, c.getCustomerNumber() );
	          ptstmt.executeUpdate();
	          	
	          ptstmt.close();                     
	          closeConnection();
	            
	        }//try
	        catch(Exception e) {
	        	e.printStackTrace();
	        	dbError = true;
	        }//catch
	         
	        if (dbError) {
		           inputSharesRequest = original;
		           inputSharesRequest.setReturnCode(new Integer(BrokerageDatabaseConstants.ERROR));
		    }//if
		    else {
		       inputSharesRequest.setUpdatedTotalQuantityOfShares( updatedTotalQuantityOfShares );
		       inputSharesRequest.setCashAmount( cashBalance );
	           inputSharesRequest.setReturnCode(new Integer(BrokerageDatabaseConstants.SUCCESS));
		    }
	        
	        return inputSharesRequest;


		}

		public SharesRequest sellShares(SharesRequest inputSharesRequest) {
			
	 		SharesRequest original = inputSharesRequest;
	 		
	 		boolean dbError = false;

	 		boolean bCustomerSellingAllSharesOfThisStock = false;
	 		int     iStockSymbolIndex = -1;
	 		Integer updatedTotalQuantityOfShares = null;

        	String[] stockSymbols = null;
        	Integer[] quantity = null;
    	    Double totalProceedOfSale  = null;
      	    Double totalProceedOfSaleMinusFee = null;
      	    Double cashBalance  = null;	          	  
	 		
        	Customer c = new Customer();
        	c.setCustomerNumber( inputSharesRequest.getCustomerNumber() );
        	
        	

			
         try {

         	  c = retrieveCustomer( c );
         	  
         	  stockSymbols = c.getStockSymbols();
         	  quantity     = c.getQuantityOfShares();
         	  
         	  if ( c.getReturnCode().intValue() == BrokerageDatabaseConstants.ERROR ) {
         	  	 throw new Exception("Customer '" + inputSharesRequest.getCustomerNumber() + "' does not exist.");
         	  }//if

         	  if ( stockSymbols == null ) {
        	  	 throw new Exception("Customer '" + inputSharesRequest.getCustomerNumber() + "' does not own '" + inputSharesRequest.getStockSymbol() + "' shares.");
        	  }//if
         	  

         	  if ( stockSymbols != null) {
         	  	 for(int i=0; i<stockSymbols.length;i++){
         	  	 	if ( stockSymbols[i].equals( inputSharesRequest.getStockSymbol() )  ) {
         	  	 	   iStockSymbolIndex = i;
         	  	 	   break;
         	  	 	}//if
         	  	 }//for
         	  }//if

              if ( iStockSymbolIndex == -1 ) {
       	  	     throw new Exception("Customer '" + inputSharesRequest.getCustomerNumber() + "' does not own '" + inputSharesRequest.getStockSymbol() + "' shares.");
       	      }//if

              if ( inputSharesRequest.getQuantityOfShares().intValue() > quantity[iStockSymbolIndex].intValue() ) {
      	  	     throw new Exception("Customer '" + inputSharesRequest.getCustomerNumber() + "' only has " + quantity[iStockSymbolIndex].intValue() + "  '" + inputSharesRequest.getStockSymbol() + "' shares. Cannot sell " + inputSharesRequest.getQuantityOfShares() + " shares.");
      	      }//if

              
	          updatedTotalQuantityOfShares = new Integer(  quantity[iStockSymbolIndex].intValue() - inputSharesRequest.getQuantityOfShares().intValue() );              

	          if ( updatedTotalQuantityOfShares.intValue() == 0 ) {
	              bCustomerSellingAllSharesOfThisStock = true;
	          }//if
	          
	          Connection con = getConnection();
	          PreparedStatement ptstmt = null;

          	  totalProceedOfSale         = new Double( inputSharesRequest.getQuantityOfShares().intValue() * inputSharesRequest.getPricePerShare().doubleValue()  );
          	  totalProceedOfSaleMinusFee = new Double( totalProceedOfSale.doubleValue() - inputSharesRequest.getCommission().doubleValue() );

          	  cashBalance  = c.getCashBalance(); //current balance	          	  
          	  cashBalance = new Double(  cashBalance.doubleValue() + totalProceedOfSaleMinusFee.doubleValue() );

	          
	          if (bCustomerSellingAllSharesOfThisStock) {
	          	
	          	  //delete from stocks where customernumber = ? and symbol = ?
		          String sDeleteSQL = null;            
		          sDeleteSQL = "delete from stocks where customernumber = ? and symbol = ?";
		          sDeleteSQL = sDeleteSQL.toUpperCase();            
		          
		          ptstmt = con.prepareStatement(sDeleteSQL);
		          ptstmt.setString(1, inputSharesRequest.getCustomerNumber() );                                                
		          ptstmt.setString(2, inputSharesRequest.getStockSymbol() );		          
		          ptstmt.executeUpdate();
	          	
	          	//update the customers table 
		          String sUpdateSQL = null;            
		          sUpdateSQL = "update customers set cashBalance = ? where customernumber = ?";
		          sUpdateSQL = sUpdateSQL.toUpperCase();            
		          
		          ptstmt = con.prepareStatement(sUpdateSQL);
		          c.setNumberOfStockSymbols( new Integer( c.getNumberOfStockSymbols().intValue() - 1 ) );
		          ptstmt.setDouble(1, cashBalance.doubleValue() );
		          ptstmt.setString(2, inputSharesRequest.getCustomerNumber() );	          
		          ptstmt.executeUpdate();

	          }
	          else {//customer only selling a portion of his shares of this stock

		          String sUpdateSQL = null;            
		          sUpdateSQL = "update stocks set quantity = ? where customernumber = ? and symbol = ?";
		          sUpdateSQL = sUpdateSQL.toUpperCase();            
		          ptstmt = con.prepareStatement(sUpdateSQL);
		          ptstmt.setInt(1, updatedTotalQuantityOfShares.intValue() );	          
		          ptstmt.setString(2, inputSharesRequest.getCustomerNumber() );
		          ptstmt.setString(3, inputSharesRequest.getStockSymbol() );	          
		          ptstmt.executeUpdate();
	          	
	          	//update the customers table 
		          sUpdateSQL = null;            
		          sUpdateSQL = "update customers set cashBalance = ? where customernumber = ?";
		          sUpdateSQL = sUpdateSQL.toUpperCase();            
		          
		          ptstmt = con.prepareStatement(sUpdateSQL);
		          ptstmt.setDouble(1, cashBalance.doubleValue() );
		          ptstmt.setString(2, inputSharesRequest.getCustomerNumber() );	          
		          ptstmt.executeUpdate();
	          	
	          }
	          
	          	
	          ptstmt.close();                     
	          closeConnection();
	            
	        }//try
	        catch(Exception e) {
	        	e.printStackTrace();
	        	dbError = true;
	        }//catch
	         
	        if (dbError) {
		           inputSharesRequest = original;
		           inputSharesRequest.setReturnCode(new Integer(BrokerageDatabaseConstants.ERROR));
		    }//if
		    else {
		       inputSharesRequest.setUpdatedTotalQuantityOfShares( updatedTotalQuantityOfShares );
		       inputSharesRequest.setCashAmount( cashBalance );
	           inputSharesRequest.setReturnCode(new Integer(BrokerageDatabaseConstants.SUCCESS));
		    }
	        
	        return inputSharesRequest;



		}
		
		
		private CashBalanceChangeRequest alterCashBalance(CashBalanceChangeRequest inputCashBalanceChangeRequest) {
			
			boolean dbError = false;
			CashBalanceChangeRequest original = inputCashBalanceChangeRequest;

        	Customer c = new Customer();
        	c.setCustomerNumber( inputCashBalanceChangeRequest.getCustomerNumber() );
			
     	    Double cashBalance        = null;
     	    Double updatedCashBalance = null;
			
			try {
				
				c = retrieveCustomer( c );
         	    if ( c.getReturnCode().intValue() == BrokerageDatabaseConstants.ERROR ) {
	         	  	 throw new Exception("Customer '" + inputCashBalanceChangeRequest.getCustomerNumber() + "' does not exist.");
	         	}//if
				
         	    cashBalance        = c.getCashBalance();
         	    updatedCashBalance = new Double( cashBalance.doubleValue() + inputCashBalanceChangeRequest.getAmount().doubleValue() );
         	    
  	          Connection con = getConnection();
	          PreparedStatement ptstmt = null;
         	    
	          //update the customers table 
	          String sUpdateSQL = null;            
	          sUpdateSQL = "update customers set cashBalance = ? where customernumber = ?";
	          sUpdateSQL = sUpdateSQL.toUpperCase();            
	          
	          ptstmt = con.prepareStatement(sUpdateSQL);
	          ptstmt.setDouble(1, updatedCashBalance.doubleValue() );
	          ptstmt.setString(2, inputCashBalanceChangeRequest.getCustomerNumber() );	          
	          ptstmt.executeUpdate();
				
	          ptstmt.close();                     
	          closeConnection();
	          
			}//try
			catch(Exception e){
				dbError = true;
				e.printStackTrace();
			}//catch

	        if (dbError) {
	        	inputCashBalanceChangeRequest = original;
	        	inputCashBalanceChangeRequest.setReturnCode(new Integer(BrokerageDatabaseConstants.ERROR));
		    }//if
		    else {
		    	inputCashBalanceChangeRequest.setUpdatedBalance( updatedCashBalance );
		    	inputCashBalanceChangeRequest.setReturnCode(new Integer(BrokerageDatabaseConstants.SUCCESS));
		    }
			
			return inputCashBalanceChangeRequest;
		}
		
		public CashBalanceChangeRequest deposit(CashBalanceChangeRequest inputCashBalanceChangeRequest) {
			return alterCashBalance( inputCashBalanceChangeRequest) ;
		}

		public CashBalanceChangeRequest withdraw(CashBalanceChangeRequest inputCashBalanceChangeRequest) {
			inputCashBalanceChangeRequest.setAmount( new Double(inputCashBalanceChangeRequest.getAmount().doubleValue() * -1.0) );
			return alterCashBalance( inputCashBalanceChangeRequest );
		}
		
	  
	    public WebLoginInfo validateWebUser(WebLoginInfo req) {
	    	WebLoginInfo resp = req;
	    	resp.setReturnCode( new Integer(BrokerageDatabaseConstants.SUCCESS) );
	    	return resp;
	    }
}
