/*   
 * Licensed Materials - Property of IBM
 * 
 * 		5724-I66
 * 
 * (C) Copyright IBM Corporation 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */ 
package com.emerged.jspbeans;



public class Caller {


	
	private  com.ibm.websphere.sca.ServiceManager serviceManager = null;		
	private  com.ibm.websphere.bo.BOFactory boFactory            = null;

	private  com.ibm.websphere.sca.Service service                  = null;
	private  com.ibm.websphere.sca.scdl.OperationType operationType = null;

	
	public Caller() {
		super();
        serviceManager = new com.ibm.websphere.sca.ServiceManager();	
	 	boFactory = (com.ibm.websphere.bo.BOFactory)serviceManager.locateService("com/ibm/websphere/bo/BOFactory");
		
	}

	public void setService(String standAloneReferenceName) {
		
    	try {
    		service = (com.ibm.websphere.sca.Service)serviceManager.locateService(standAloneReferenceName);    		
    	}//try
    	catch(Exception e){
    		e.printStackTrace();
    		service = null;
    	}//catch
		
	}
	
	public void setOperation(String operationName) {
		
		try {
		    operationType = service.getReference().getOperationType(operationName);
		}//try
		catch(Exception e){
		    e.printStackTrace();
		    operationType = null;		    
		}//catch
	}
	
    public commonj.sdo.DataObject getOperationInputBusinessObject(String inputParameterName) {
    	commonj.sdo.DataObject inputBusinessObject = null;
    	
    	try {
  
    		   if( operationType.isWrapperType( operationType.getInputType() ) )
    		   {
    		   	inputBusinessObject = boFactory.createByType(operationType.getInputType().getProperty(inputParameterName).getType());
    		   }
    		
    	}//try
    	catch(Exception e){
    		e.printStackTrace();
    	}//catch
    	
    	return inputBusinessObject;
    }
    
	
	public Object invokeCurrentOperation(String operationInputParameterName,Object inputObject,String operationOutputParameterName) {
		
		Object outputObject = null;
		
		
        String[] operationInputParameterNames = new String[1];
        operationInputParameterNames[0] = operationInputParameterName;
        
        Object[] inputObjects = new Object[1];
        inputObjects[0]       = inputObject;
    
        String[] operationOutputParameterNames = new String[1];
        operationOutputParameterNames[0] = operationOutputParameterName;
        
        Object[] outputObjects = null;
        
        //call master invoker
        outputObjects = invokeCurrentOperation(operationInputParameterNames,inputObjects,operationOutputParameterNames);
        
        
        outputObject = outputObjects[0];
        
		
		return outputObject;
	}

	public Object[] invokeCurrentOperation(String operationInputParameterName,Object inputObject,String[] operationOutputParameterNames) {
		
        Object[] outputObjects = null;
		
		
        String[] operationInputParameterNames = new String[1];
        operationInputParameterNames[0] = operationInputParameterName;
        
        Object[] inputObjects = new Object[1];
        inputObjects[0]       = inputObject;

        //call master invoker
        outputObjects = invokeCurrentOperation(operationInputParameterNames,inputObjects,operationOutputParameterNames);
        
		return outputObjects;
	}
	
	public Object invokeCurrentOperation(String[] operationInputParameterNames,Object[] inputObjects,String operationOutputParameterName) {
		
		Object outputObject = null;
		
        String[] operationOutputParameterNames = new String[1];
        operationOutputParameterNames[0] = operationOutputParameterName;
        
        Object[] outputObjects = null;
        
        //call master invoker
        outputObjects = invokeCurrentOperation(operationInputParameterNames,inputObjects,operationOutputParameterNames);
        
        outputObject = outputObjects[0];

		
		return outputObject;
	}

	public Object[] invokeCurrentOperation(String[] operationInputParameterNames,Object[] inputObjects,String[] operationOutputParameterNames) {
		
		Object[] outputObjects = null;
		
		commonj.sdo.DataObject operationInput         = null;	   	
		commonj.sdo.DataObject operationOutput        = null;
		
		try {
			
		   //	
		   //set up the input object for the operation
		   //
			
 		   if( operationType.isWrapperType( operationType.getInputType() ) )
		   {
              // 		   	
 		   	  //the operation input needs to be a wrapper object that contains the input data object
 		   	  //
 		   	
 		   	  //create the wrapper object
 		      operationInput = boFactory.createByType(operationType.getInputType());
 		      
 		      //insert the input data objects into the wrapper object
 		      for(int i=0;i<operationInputParameterNames.length;i++){
 		          operationInput.set(operationInputParameterNames[i], inputObjects[i]);
 		      }
		   }

 		   //call the operation 
 		   operationOutput = (commonj.sdo.DataObject)service.invoke(operationType.getName(), operationInput);
 		   
 		   
           //
 		   //analyze the returned object
 		   //
 		   if(operationType.isWrapperType(operationType.getOutputType()))
 		   {
 		   	  // the object returned from the invoked operation is a wrapper object.
 		   	  // exract the data object(s) from the wrapper object.
 		      outputObjects = new Object[operationOutputParameterNames.length];
 		   	  for(int i=0;i<outputObjects.length;i++){
 		   	    outputObjects[i] = operationOutput.get(operationOutputParameterNames[i]);
 		   	  }//for
 		   }//if

			
		}
		catch(Exception e){
			e.printStackTrace();
		}
		
		return outputObjects;
	}
	
	public commonj.sdo.DataObject createBO(String boName,String boNamespace) {
		commonj.sdo.DataObject sdo = null;
		
		try {
			
			//create the requested sdo data object
			sdo = boFactory.create(boNamespace, boName);
			
		}
		catch(Exception e){
			e.printStackTrace();
		}
		
		return sdo;
	}
    
}
