/*
 * Licensed Materials - Property of IBM
 * 
 * 		5724-I66
 * 
 * (C) Copyright IBM Corporation 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */ 
package com.emerged.jspbeans;

public class LoginFormBean {
	
    private com.emerged.jspbeans.Caller util = null;
    
	public LoginFormBean() {
		super();
        //get the utility class for calling stand-alone references		
        util = new com.emerged.jspbeans.Caller();
	}
	
	public boolean validate(String customerNumber, String password) {
		
		boolean bValid = false;
		
		try {
			
			//Name of BankModule's stand-alone reference
			String standAloneReferenceName = "BankInterfacePartner";
			
			//eMergedLibrary's BankInterface.wsdl  operation
			String operationName           = "authenticate";

			
			//set the standalone reference
			util.setService(standAloneReferenceName);
			
			//set the operation
			util.setOperation(operationName);
			

			
			
		    //set the wsdl operation input parameter names
		    String[] operationInputParameterNames         =  new String[]{"customerName","password"};
		    
		    //set the wsdl operation output parameter name    
		    String operationOutputParameterName        = "result";	
			
		    
			Object[] input_parameters = new Object[operationInputParameterNames.length];
			input_parameters[0] = customerNumber;
			input_parameters[1] = password;
			Boolean result = null;

		    //invoke the operation with the input data objects 
		    result = (Boolean) util.invokeCurrentOperation(operationInputParameterNames,input_parameters,operationOutputParameterName);

		    bValid = result.booleanValue();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		
		
		return bValid;
	}
	

	
}
