/*
 * Licensed Materials - Property of IBM
 * 
 * 		5724-I66
 * 
 * (C) Copyright IBM Corporation 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */ 
package com.emerged.jspbeans;




public class TopNavBean {

    private com.emerged.jspbeans.Caller util = null;
    
    
	public TopNavBean() {
		super();
        util = new com.emerged.jspbeans.Caller(); 
	}
	
	
	public Object[] getPortalInfo(String customerNumber) {

		Object[] output_Objects                            = null;
		
		try {
			
			//Name of BankModule's stand-alone reference
			String standAloneReferenceName = "PortalInterfacePartner";
			
			//eMergedLibrary's BankInterface.wsdl  operation
			String operationName           = "gatherPortalInfo";

			
			//set the standalone reference
			util.setService(standAloneReferenceName);
			
			//set the operation
			util.setOperation(operationName);
			
		    //set the wsdl operation input parameter name
		    String operationInputParameterName         =  "customer";
		    
		    //set the wsdl operation output parameter names    
		    String[] operationOutputParameterNames        = new String[]{"portalInfo","currencyRateCAD","currencyRateUSD","currencyRateGBP"};	
			
			commonj.sdo.DataObject input_CustomerBO            = null;		    

			
			//create the input customer business object
			input_CustomerBO = util.getOperationInputBusinessObject(operationInputParameterName);
			//set the input customer business object's customerNumber field
			input_CustomerBO.set("customerNumber",customerNumber);
			
			
		    //invoke the operation with the input data object 
			output_Objects = util.invokeCurrentOperation(operationInputParameterName,input_CustomerBO,operationOutputParameterNames);

		}
		catch(Exception e) {
			e.printStackTrace();
			output_Objects = null;
		}
		
		return output_Objects;

	}
	
}
